Index: java/main/src/main/java/com/framsticks/params/ReflectionAccessBackend.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ReflectionAccessBackend.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ReflectionAccessBackend.java	(revision 105)
@@ -81,5 +81,5 @@
 
 		try {
-			for (final ProcedureParam pp : filterInstanceof(framsClass.getParamEntries(), ProcedureParam.class)) {
+			for (final ProcedureParam pp : filterInstanceof(framsClass.getParams(), ProcedureParam.class)) {
 				if (!candidates.containsKey(pp.getId())) {
 					log.trace("java class does implement method {}", pp);
@@ -99,5 +99,5 @@
 			}
 
-			for (final EventParam ep : filterInstanceof(framsClass.getParamEntries(), EventParam.class)) {
+			for (final EventParam ep : filterInstanceof(framsClass.getParams(), EventParam.class)) {
 				if (!candidates.containsKey(ep.getId())) {
 					log.trace("java class does not implement the event param {}", ep);
@@ -125,5 +125,5 @@
 			}
 
-			for (final ValueParam vp : filterInstanceof(framsClass.getParamEntries(), ValueParam.class)) {
+			for (final ValueParam vp : filterInstanceof(framsClass.getParams(), ValueParam.class)) {
 				if (!candidates.containsKey(vp.getId())) {
 					throw new ConstructionException().msg("missing candidate for param").arg("param", vp);
@@ -228,5 +228,5 @@
 		}
 		if (!a.isPrimitive()) {
-			return a.equals(b);
+			return b.isAssignableFrom(a);//equals(b);
 		}
 
Index: java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/SimpleAbstractAccess.java	(revision 105)
@@ -1,6 +1,3 @@
 package com.framsticks.params;
-
-
-
 
 import com.framsticks.params.types.ObjectParam;
@@ -36,5 +33,5 @@
 
 	@Override
-	public String getId() {
+	public String getTypeId() {
 		return framsClass.getId();
 	}
@@ -62,20 +59,20 @@
 	@Override
 	public <T> T get(int i, Class<T> type) {
-		return get(framsClass.getParamEntry(i, ValueParam.class), type);
+		return get(ParamsUtil.getParam(framsClass, i, ValueParam.class), type);
 	}
 
 	@Override
 	public <T> T get(String id, Class<T> type) {
-		return get(framsClass.getParamEntry(id, ValueParam.class), type);
+		return get(ParamsUtil.getParam(framsClass, id, ValueParam.class), type);
 	}
 
 	@Override
 	public <T> int set(int i, T value) {
-		return set(framsClass.getParamEntry(i, ValueParam.class), value);
+		return set(ParamsUtil.getParam(framsClass, i, ValueParam.class), value);
 	}
 
 	@Override
 	public <T> int set(String id, T value) {
-		return set(framsClass.getParamEntry(id, ValueParam.class), value);
+		return set(ParamsUtil.getParam(framsClass, id, ValueParam.class), value);
 	}
 
@@ -107,5 +104,5 @@
 	@Override
 	public Iterable<Param> getParams() {
-		return framsClass.getParamEntries();
+		return framsClass.getParams();
 	}
 
@@ -122,5 +119,5 @@
 	@Override
 	public ParamBuilder buildParam(ParamBuilder builder) {
-		return builder.name(getId()).type(ObjectParam.class).containedTypeName(getId());
+		return builder.name(getTypeId()).type(ObjectParam.class).containedTypeName(getTypeId());
 	}
 
Index: java/main/src/main/java/com/framsticks/params/SimplePrimitive.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimplePrimitive.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/SimplePrimitive.java	(revision 105)
@@ -1,5 +1,5 @@
 package com.framsticks.params;
 
-import com.framsticks.core.ValueChange;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.util.lang.Strings;
 
Index: java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/SimpleUniqueList.java	(revision 105)
@@ -5,5 +5,5 @@
 import java.util.Map;
 
-import com.framsticks.core.ListChange;
+import com.framsticks.structure.messages.ListChange;
 
 public class SimpleUniqueList<T extends UniqueObject> implements Iterable<T> {
Index: java/main/src/main/java/com/framsticks/params/UniqueListAccess.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/UniqueListAccess.java	(revision 105)
@@ -140,6 +140,6 @@
 
 	@Override
-	public String getId() {
-		return "l " + elementAccess.getId() + " " + uidName;
+	public String getTypeId() {
+		return "l " + elementAccess.getTypeId() + " " + uidName;
 	}
 
Index: java/main/src/main/java/com/framsticks/params/ValueParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/ValueParam.java	(revision 105)
@@ -1,4 +1,3 @@
 package com.framsticks.params;
-
 
 import javax.annotation.concurrent.Immutable;
@@ -23,3 +22,13 @@
 	public abstract <T> T getDef(Class<T> type);
 
+	public abstract Class<?> getStorageType();
+
+	public boolean isNumeric() {
+		return false;
+	}
+
+	public abstract <T> String serialize(T value);
+
+	public abstract <T> T deserialize(String text, T currentValue, Class<T> type);
+
 }
Index: java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 105)
@@ -49,10 +49,10 @@
 			// List<?> list;
 			// if (oldValue == null) {
-			// 	list = new ArrayList<Object>();
+			//	list = new ArrayList<Object>();
 			// } else {
-			// 	list = Casting.tryCast(List.class, oldValue);
-			// 	if (list == null) {
-			// 		throw new CastFailure();
-			// 	}
+			//	list = Casting.tryCast(List.class, oldValue);
+			//	if (list == null) {
+			//		throw new CastFailure();
+			//	}
 			// }
 			// Containers.resizeList(list, size);
@@ -61,5 +61,5 @@
 		}
 		// if (oldValue != null) {
-		// 	return new ReassignResult<List<?>>(Casting.throwCast(List.class, oldValue));
+		//	return new ReassignResult<List<?>>(Casting.throwCast(List.class, oldValue));
 		// }
 		return new ReassignResult<List<?>>(Casting.throwCast(List.class, newValue));
@@ -70,3 +70,5 @@
 		return "l " + getContainedTypeName();
 	}
+
+		// return (value == null) ? "0" : Integer.toString(Casting.throwCast(List.class, value).size());
 }
Index: java/main/src/main/java/com/framsticks/params/types/BooleanParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 105)
@@ -7,5 +7,4 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
-import com.framsticks.params.Sink;
 import com.framsticks.util.lang.Numbers;
 
@@ -58,7 +57,7 @@
 
 	@Override
-	public void save(Sink sink, Object value) {
+	public String serialize(Object value) {
 		assert value instanceof Boolean;
-		sink.print(((Boolean)value) ? "1" : "0");
+		return ((Boolean)value) ? "1" : "0";
 	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/EventParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 105)
@@ -24,9 +24,4 @@
 
 	@Override
-	public Class<?> getStorageType() {
-		return Void.TYPE;
-	}
-
-	@Override
 	public String getFramsTypeName() {
 		return eventArgumentTypeName != null ? "e " + eventArgumentTypeName : "e";
Index: java/main/src/main/java/com/framsticks/params/types/ListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 105)
@@ -16,3 +16,12 @@
 	}
 
+	@Override
+	public <T> String serialize(T value) {
+		return null;
+	}
+
+	@Override
+	public <T> T deserialize(String text, T currentValue, Class<T> type) {
+		return null;
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/ObjectParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 105)
@@ -5,4 +5,5 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.ParamsUtil;
 import com.framsticks.params.ReassignResult;
 
@@ -50,4 +51,13 @@
 	}
 
+	@Override
+	public <T> String serialize(T value) {
+		return ParamsUtil.serialize(value);
+	}
+
+	@Override
+	public <T> T deserialize(String text, T currentValue, Class<T> type) {
+		return ParamsUtil.deserialize(text, type);
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 105)
@@ -52,9 +52,4 @@
 	}
 
-	@Override
-	public Class<?> getStorageType() {
-		return Void.TYPE;
-	}
-
 	public @Nullable ValueParam getResultType() {
 		return resultType;
Index: java/main/src/main/java/com/framsticks/params/types/StringParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 105)
@@ -5,5 +5,4 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
-import com.framsticks.params.Sink;
 
 import javax.annotation.concurrent.Immutable;
@@ -49,8 +48,8 @@
 
 	@Override
-	public void save(Sink sink, Object value) {
+	public String serialize(Object value) {
 		assert value instanceof String;
-		String s = (String)value;
-		sink.print((s.contains(SEPARATOR) ? (s = "~" + SEPARATOR + s + "~") : s));
+		String s = (String) value;
+		return (s.contains(SEPARATOR) ? (s = "~" + SEPARATOR + s + "~") : s);
 	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/UniversalParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/UniversalParam.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/params/types/UniversalParam.java	(revision 105)
@@ -3,4 +3,5 @@
 import com.framsticks.params.CastFailure;
 import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.ParamsUtil;
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.ReassignResult;
@@ -37,3 +38,13 @@
 	}
 
+	@Override
+	public <T> String serialize(T value) {
+		return ParamsUtil.serialize(value);
+	}
+
+	@Override
+	public <T> T deserialize(String text, T currentValue, Class<T> type) {
+		return ParamsUtil.deserialize(text, type);
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/parsers/AccessStash.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/AccessStash.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/parsers/AccessStash.java	(revision 105)
@@ -18,5 +18,5 @@
 	public AccessStash add(Access access) {
 		/**TODO: by id or by name? rather by id, because from file is always lowercase*/
-		accesses.put(access.getId(), access);
+		accesses.put(access.getTypeId(), access);
 		return this;
 	}
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 105)
@@ -233,5 +233,5 @@
 							throw (new Exception("tried to set a read-only attribute \""
 								+ currentParam.getId()
-								+ "\" in class \"" + access.getId() + "\""));
+								+ "\" in class \"" + access.getTypeId() + "\""));
 						}
 					}
@@ -258,5 +258,5 @@
 				+ param.getId()
 				+ "\" in class \""
-				+ access.getId()
+				+ access.getTypeId()
 				+ "\" to value which exceeds " + name + " ("
 				+ value
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 105)
@@ -38,5 +38,5 @@
 		}
 		StringBuilder line = new StringBuilder();
-		line.append(access.getId()).append(":");
+		line.append(access.getTypeId()).append(":");
 		boolean placeComma = false;
 		boolean contiguous = true;
Index: java/main/src/main/java/com/framsticks/parsers/Savers.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/parsers/Savers.java	(revision 105)
@@ -19,5 +19,5 @@
 
 		save(framsClassAccess, sink);
-		for (Param p : framsClass.getParamEntries()) {
+		for (Param p : framsClass.getParams()) {
 			save(paramAccess.select(p), sink);
 		}
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 105)
@@ -27,4 +27,5 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Strings;
+import static com.framsticks.params.ParamsUtil.getParam;
 
 public class XmlLoader {
@@ -110,5 +111,5 @@
 		for (int i = 0; i < attributes.getLength(); ++i) {
 			Node attributeNode = attributes.item(i);
-			PrimitiveParam<?> param = access.getFramsClass().getParamEntry(mangleAttribute(attributeNode.getNodeName()), PrimitiveParam.class);
+			PrimitiveParam<?> param = getParam(access, mangleAttribute(attributeNode.getNodeName()), PrimitiveParam.class);
 			if (param.hasFlag(ParamFlags.READONLY)) {
 				throw new FramsticksException().msg("cannot configure readonly param").arg("param", param).arg("in", access);
Index: java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 105)
@@ -1,14 +1,12 @@
 package com.framsticks.remote;
 
-import static com.framsticks.core.TreeOperations.*;
 
-import com.framsticks.core.Node;
-import com.framsticks.core.Path;
 import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
-import com.framsticks.params.FramsClass;
-import com.framsticks.core.Tree;
+import com.framsticks.structure.Node;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.Tree;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.FramsticksException;
@@ -17,4 +15,6 @@
 import org.apache.logging.log4j.Logger;
 import org.apache.logging.log4j.LogManager;
+
+import static com.framsticks.structure.TreeOperations.*;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 import com.framsticks.util.dispatching.RunAt;
@@ -28,9 +28,9 @@
 
 	protected final Tree tree;
-	protected final Future<Void> future;
+	protected final FutureHandler<Void> future;
 	protected int dispatched;
 	protected final Stopwatch stopwatch = new Stopwatch();
 
-	public RecursiveFetcher(Tree tree, final Path path, Future<Void> future) {
+	public RecursiveFetcher(Tree tree, final Path path, FutureHandler<Void> future) {
 		this.tree = tree;
 		this.future = future;
@@ -51,6 +51,4 @@
 		} else {
 			Access access = bindAccess(path);
-			FramsClass framsClass = access.getFramsClass();
-			assert framsClass != null;
 			for (CompositeParam p : filterInstanceof(access.getParams(), CompositeParam.class)) {
 				Object child = access.get(p, Object.class);
@@ -67,5 +65,5 @@
 				}
 				++dispatched;
-				tree.get(childPath, new FutureHandler<Path>(Logging.logger(log, "resolve", RecursiveFetcher.this)) {
+				tree.get(childPath, new Future<Path>(Logging.logger(log, "resolve", RecursiveFetcher.this)) {
 					@Override
 					protected void result(Path result) {
@@ -83,5 +81,5 @@
 
 	protected void fetch(final Path path) {
-		tree.get(path, new Future<Path>() {
+		tree.get(path, new FutureHandler<Path>() {
 
 			@Override
Index: java/main/src/main/java/com/framsticks/remote/RemoteTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 105)
@@ -6,8 +6,4 @@
 import com.framsticks.communication.queries.InfoRequest;
 import com.framsticks.communication.queries.SetRequest;
-import com.framsticks.core.AbstractTree;
-import com.framsticks.core.ListChange;
-import com.framsticks.core.Path;
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.*;
 import com.framsticks.params.EventListener;
@@ -17,11 +13,14 @@
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.parsers.Loaders;
+import com.framsticks.structure.AbstractTree;
+import com.framsticks.structure.Path;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.util.*;
 import com.framsticks.util.dispatching.AtOnceDispatcher;
 import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.DispatchingFuture;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Future;
-import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.Joinable;
 import com.framsticks.util.dispatching.JoinableParent;
@@ -29,5 +28,6 @@
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.dispatching.RunAt;
-import static com.framsticks.core.TreeOperations.*;
+
+import static com.framsticks.structure.TreeOperations.*;
 
 import java.util.*;
@@ -80,6 +80,6 @@
 	}
 
-	protected ExceptionResultHandler pathRemoveHandler(final Path path, final ExceptionResultHandler handler) {
-		return new ExceptionResultHandler() {
+	protected ExceptionHandler pathRemoveHandler(final Path path, final ExceptionHandler handler) {
+		return new ExceptionHandler() {
 
 			@Override
@@ -114,5 +114,5 @@
 	// }
 
-	protected final Map<String, Set<Future<FramsClass>>> infoRequests = new HashMap<String, Set<Future<FramsClass>>>();
+	protected final Map<String, Set<FutureHandler<FramsClass>>> infoRequests = new HashMap<String, Set<FutureHandler<FramsClass>>>();
 
 
@@ -124,5 +124,5 @@
 	 * */
 	@Override
-	public void info(final Path path, final Future<FramsClass> future) {
+	public void info(final Path path, final FutureHandler<FramsClass> future) {
 
 		final String name = path.getTop().getParam().getContainedTypeName();
@@ -134,9 +134,9 @@
 
 		log.debug("issuing info request for {}", name);
-		final Set<Future<FramsClass>> futures = new HashSet<Future<FramsClass>>();
+		final Set<FutureHandler<FramsClass>> futures = new HashSet<FutureHandler<FramsClass>>();
 		futures.add(future);
 		infoRequests.put(name, futures);
 
-		final Future<FramsClass> compositeFuture = DispatchingFuture.create(this, new Future<FramsClass>() {
+		final FutureHandler<FramsClass> compositeFuture = DispatchingFuture.create(this, new FutureHandler<FramsClass>() {
 
 			@Override
@@ -144,5 +144,5 @@
 				assert isActive();
 				infoRequests.remove(name);
-				for (Future<FramsClass> f : futures) {
+				for (FutureHandler<FramsClass> f : futures) {
 					f.handle(exception);
 				}
@@ -154,5 +154,5 @@
 				putInfoIntoCache(framsClass);
 				infoRequests.remove(name);
-				for (Future<FramsClass> f : futures) {
+				for (FutureHandler<FramsClass> f : futures) {
 					f.pass(framsClass);
 				}
@@ -183,10 +183,10 @@
 
 	@Override
-	public void get(final Path path, final Future<Path> future) {
-		assert isActive();
-		final ExceptionResultHandler remover = pathRemoveHandler(path, future);
+	public void get(final Path path, final FutureHandler<Path> future) {
+		assert isActive();
+		final ExceptionHandler remover = pathRemoveHandler(path, future);
 
 		log.trace("fetching values for {}", path);
-		findInfo(path, new FutureHandler<FramsClass>(remover) {
+		findInfo(path, new Future<FramsClass>(remover) {
 			@Override
 			protected void result(FramsClass result) {
@@ -204,5 +204,5 @@
 
 	@Override
-	public void set(final Path path, final PrimitiveParam<?> param, final Object value, final Future<Integer> future) {
+	public void set(final Path path, final PrimitiveParam<?> param, final Object value, final FutureHandler<Integer> future) {
 		assert isActive();
 		final Integer flag = bindAccess(path).set(param, value);
@@ -267,5 +267,5 @@
 
 	@Override
-	public <R> void call(@Nonnull final Path path, @Nonnull final ProcedureParam procedure, @Nonnull Object[] arguments, final Class<R> resultType, final Future<R> future) {
+	public <R> void call(@Nonnull final Path path, @Nonnull final ProcedureParam procedure, @Nonnull Object[] arguments, final Class<R> resultType, final FutureHandler<R> future) {
 		assert isActive();
 		assert path.isResolved();
@@ -294,5 +294,5 @@
 	protected final Map<EventListener<?>, EventListener<File>> proxyListeners = new IdentityHashMap<>();
 
-	public <A> void addListener(Path path, EventParam param, final EventListener<A> listener, final Class<A> argumentType, final Future<Void> future) {
+	public <A> void addListener(Path path, EventParam param, final EventListener<A> listener, final Class<A> argumentType, final FutureHandler<Void> future) {
 		assert isActive();
 		assert path.isResolved();
@@ -322,5 +322,5 @@
 	}
 
-	public void removeListener(Path path, EventParam param, EventListener<?> listener, Future<Void> future) {
+	public void removeListener(Path path, EventParam param, EventListener<?> listener, FutureHandler<Void> future) {
 		assert isActive();
 		EventListener<File> proxyListener = proxyListeners.get(listener);
Index: java/main/src/main/java/com/framsticks/running/ExternalProcess.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/running/ExternalProcess.java	(revision 105)
@@ -14,5 +14,4 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.EventListeners;
@@ -21,4 +20,5 @@
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.structure.messages.ValueChange;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.AbstractJoinable;
Index: java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 103)
+++ java/main/src/main/java/com/framsticks/running/LoggingOutputListener.java	(revision 105)
@@ -4,7 +4,7 @@
 import org.apache.logging.log4j.LogManager;
 
-import com.framsticks.core.ValueChange;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.structure.messages.ValueChange;
 
 @FramsClassAnnotation
